with Text_IO; use Text_IO;
with Lower_Layer_UDP;
with Ada.Strings.Unbounded;
with Ada.Text_IO; use Text_IO;
with Ada.Streams;
with Ada.Streams.Stream_IO;

procedure Servidor is

   package LLU renames Lower_Layer_UDP;
   package ASU renames Ada.Strings.Unbounded;
   package S_IO renames Ada.Streams.Stream_IO;

   Server_EP: LLU.End_Point_Type;
   Client_EP: LLU.End_Point_Type;
   Expired: Boolean;
   Tipo: Natural;
   Fichero: ASU.Unbounded_String;
   Buffer: aliased LLU.Buffer_Type (5120);
   -- Ultimo_Buffer: aliased LLU.Buffer_Type (4096);



   Tamano_Trozo: integer:=512;
   Plazo_Espera: Float:= 0.2;



   function A_Entero (U: ASU.Unbounded_String) return Integer is
      Long: Integer;
      Total: Integer;
   begin
      Long:= ASU.To_String(U)'Length;
      declare
         S: String := ASU.To_String(U);
      begin
         Total:= 0;
         for I in 1..Long loop
            Total:= Total* 10 +(Character'Pos(S(I))-Character'Pos('0'));
         end loop;
      end;
      return Total;
   end A_Entero;


   function A_Float (U: ASU.Unbounded_String) return Float is
      Long: Integer;
      Total:Float;
   begin
      Long:= ASU.To_String(U)'Length;
      declare
         S: String := ASU.To_STring(U);
      begin
         Total:=0.0;
         for I in 1..Long loop
            Total:= Total*10.0 + Float ((Character'Pos(S(I)) - Character'Pos('0')));
         end loop;
      end;
      return Total;
   end A_Float;







   -- ***********************************************************************************************
   -- **************************     PROCEDIMIENTO DE ESCRITURA *************************************
   -- ***********************************************************************************************

   procedure Peticion_Escritura is
      Num_Trozo: Natural;
      Num_Trozo_Ant: Natural;
      Dst_File: S_IO.File_Type;
      Salir: Boolean;
      Aux1: ASU.Unbounded_String;
      Aux2: ASU.Unbounded_String;
      Aux_Tamano, Aux_Plazo: ASU.Unbounded_String;
      Num: Natural;
   Begin
      Num:= Natural'Input (Buffer'Access);
      Aux1:= ASU.Unbounded_String'Input (Buffer'Access);
      Aux_Tamano:= ASU.Unbounded_String'Input(Buffer'Access);
      Aux2:= ASU.Unbounded_String'Input (Buffer'Access);
      Aux_Plazo:= ASU.Unbounded_String'Input(Buffer'Access);

      -- EL BUCLE SE REPITE HASTA QUE SE MANDA EL ASENTIMIENTO DE ESCRITURA Y SE RECIBE EL PRIMER
      -- PAQUETE DE DATOS
      loop

         -- METO EN EL BUFFER EL ASENTIMIENTO DE ESCRITURA Y LO MANDO AL CLIENTE

         LLU.Reset (Buffer);
         Natural'Output (Buffer'Access, 6); -- Paquete de asentimiento opciones (OACK)
         Natural'Output (Buffer'Access, 2); -- Nmero de opciones
         ASU.Unbounded_String'Output (Buffer'Access, Aux1);
         ASU.Unbounded_String'Output (Buffer'Access, Aux_Tamano);
         ASU.Unbounded_String'Output (Buffer'Access, Aux2);
         ASU.Unbounded_String'Output (Buffer'Access, Aux_Plazo);
         LLU.Send (Client_EP,Buffer'Access);
         Put_Line ("Mando asentimiento de escritura y opciones");

         -- ME QUEDO ESPERANDO HASTA RECIBIR ALGO DEL CLIENTE

         LLU.Reset (Buffer);
         LLU.Receive (Server_EP, Buffer'Access,Duration (Plazo_Espera), Expired);

         -- SI RECIBO UN PAQUETE, Y EL PAQUETE ES EL PRIMER PAQUETE DE DATOS, ME SALGO DEL BUCLE
         -- SI NO RECIBO NADA, VUELVE LA ITERACIN DEL BUCLE A MANDAR EL ASENTIMIENTO DE ESCRITURA

         if not Expired then
            Client_EP:= LLU.End_Point_Type'Input (Buffer'Access);
            Tipo:= Natural'Input (Buffer'Access);
            if Tipo=3 then exit; end if;
         end if;
      end loop;

      Tamano_Trozo:= A_Entero (Aux_Tamano);
      Plazo_Espera:= (A_Float (Aux_Plazo))/1000.0;
      -- SE CREA EL FICHERO EN EL QUE SE VA A ESCRIBIR

      S_IO.Create(Dst_File, S_IO.Out_File, ASU.To_String(Fichero) & "2");

      Num_Trozo_Ant:=0;
      Salir:= False;
      -- ESTE BUCLE SE REPITE HASTA QUE SE HAN RECIBIDO TODOS LOS TROZOS DEL FICHERO, Y HAN SDO
      -- ESCRITOS EN L

      loop

         -- SACO LOS DATOS DEL BUFFER

         Num_Trozo:= Natural'Input (Buffer'Access);
         Put_Line ("Recibo trozo :" & Integer'Image (Num_Trozo));
         declare
            Trozo: Ada.Streams.Stream_Element_Array:=
              Ada.Streams.Stream_Element_Array'Input (Buffer'Access);
         begin

            -- SI EL TROZO RECIBIDO ES EL SIGUIENTE DEL FICHERO, LO ESCRIBO EN L

            if Num_Trozo_Ant=Num_Trozo-1 then
               S_IO.Write (Dst_File, Trozo);
               Num_Trozo_Ant:= Num_Trozo;
            end if;

            -- ESTE BUCLE SE REPITE HASTA QUE SE HA RECIBIDO ALGO DEL CLIENTE, O TAMBIN SE SALE DE L
            -- SI EL LTIMO TROZO RECIBIDO ES < Tamano_Trozo

            loop
               -- MANDO ASENTIMIENTO DEL LTIMO TROZO RECIBIDO

               LLU.Reset (Buffer);
               Natural'Output (Buffer'Access, 4); -- Paquete de asentimiento
               Natural'Output (Buffer'Access, Num_Trozo);
               LLU.Send (Client_EP, Buffer'Access);
               Put_Line ("Mando asentimiento del trozo " & Integer'Image (Num_Trozo));

               -- ME QUEDO ESPERANDO PARA RECIBIR OTRO TROZO

               LLU.Reset (Buffer);
               LLU.Receive (Server_EP, Buffer'Access,Duration (Plazo_Espera), Expired);

               -- SI NO RECIBO NADA Y EL LTIMO TROZO ESCRITO ERA MENOR DE Tamano_Trozo bytes ME SALGO DEL BUCLE
               -- SI RECIBO ALGN PAQUETE TAMBIN ME SALGO DEL BUCLE

               if Expired then
                  if Trozo'Length <Tamano_Trozo then
                     Salir:= True;
                     exit;
                  end if;
               else
                  exit;
               end if;
            end loop;


            -- SI EL TROZO ESCRITO ERA EL LTIMO, ME SALGO DEL BUCLE
            -- SI NO ERA EL LTIMO, VUELVE LA ITERACIN DEL BUCLE Y COMPRUEBA LOS DATOS QUE LE HA ENVIADO
            -- EL CLIENTE

            if Salir then
               exit;
            else
               Client_EP:= LLU.End_Point_Type'Input (Buffer'Access);
               Tipo:= Natural'Input (Buffer'Access);
            end if;
         end; -- FIN DEL DECLARE
         End loop;

      -- ME QUEDO ESPERANDO DURANTE 5 SEGUNDOS DESPUS DE MANDAR EL LTIMO ASENTIMIENTO POR
      -- SI STE SE PIERDE, SI RECIBO DE NUEVO EL LTIMO TROZO DE FICHERO, VUELVO A MANDAR EL
      -- ASENTIMIENTO Y ME QUEDO ESPERANDO OTROS 5 SEGUNDOS, SI NO RECIBO NADA EN LOS 5 SEGUNDOS
      -- CIERRO EL FICHERO, Y DOY POR TERMINADA LA CONEXIN

      loop
         LLU.Reset (Buffer);
         LLU.Receive (Server_EP, Buffer'Access,5.0, Expired);
         exit when Expired;
         LLU.Reset (Buffer);
         Natural'Output (Buffer'Access, 4); -- Paquete de asentimiento
         Natural'Output (Buffer'Access, Num_Trozo);
         LLU.Send (Client_EP, Buffer'Access);
         Put_Line ("Mando asentimiento del trozo " & Integer'Image (Num_Trozo));
      end loop;

      S_IO.Close (Dst_File);
   end Peticion_Escritura;



   -- *******************************************************************************************************
   -- ************************************** PROCEDIMIENTO DE LECTURA ***************************************
   -- *******************************************************************************************************


   procedure Peticion_Lectura is

      Numero_Trozo: Natural; -- Nmero de asentimiento de trozo que se lee del buffer
      Num_Trozo_Aux: Natural; -- Nmero del ltimo trozo asentido
      -- Trozo: Ada.Streams.Stream_Element_Array (1..Tamano_Trozo);
      Ultimo: Ada.Streams.Stream_Element_Offset; -- Indica el tamao del trozo que se lee del buffer
      Salir: Boolean;
      Direccion_Fichero: S_IO.File_Type; -- Variable que hace referencia al fichero donde se lee

   begin

      -- ABRO EL FICHERO

      S_IO.Open (Direccion_Fichero,S_IO.In_File, ASU.To_String(Fichero));
      Put_Line ("Abro el fichero");

      Numero_Trozo:= 0;
      Num_Trozo_Aux:= 0;
      Salir:=False;

      declare
         Trozo: Ada.Streams.Stream_Element_Array (1..Ada.Streams.Stream_Element_Offset (Tamano_Trozo));
      Salir: Boolean;
      begin
         if S_IO.End_Of_File (Direccion_Fichero) then
            loop
               Numero_Trozo:= 1;
               LLU.Reset (Buffer);
               Natural'Output (Buffer'Access, 3);
               Natural'Output (Buffer'Access, Numero_Trozo);
               Ada.Streams.Stream_Element_Array'Output (Buffer'Access, Trozo(1..0));
               LLU.Send (Client_EP, Buffer'Access);
               Put_Line ("Mando la parte del fichero" & Integer'Image (Numero_Trozo));

               LLU.Reset (Buffer);
               LLU.Receive (Server_EP, Buffer'Access,Duration(Plazo_Espera), Expired);

               -- SI HE RECIBIDO ALGO ME SALGO DEL BUCLE. SI NO, SE EJECUTA OTRA ITERACIN DEL BUCLE Y VUELVO A
               -- MANDAR EL LTIMO TROZO DE FICHERO
               if not Expired then
                  -- EXTRAIGO DEL BUFFER LOS DATOS DEL ASENTIMIENTO DEL CLIENTE
                  Client_EP:= LLU.End_Point_Type'Input (Buffer'Access);
                  Tipo:= Natural'Input (Buffer'Access);
                  if Tipo=4 then
                     Num_Trozo_Aux:= Natural'Input (Buffer'Access);
                     Put_Line ("Recibo asentimiento del trozo: " & Integer'Image (Num_Trozo_Aux));
                     if Numero_Trozo /= Num_Trozo_Aux then
                        Expired:= true;
                     end if;
                  else
                     Expired:=True;
                  end if;
               end if;

               if  not Expired then exit; end if;
            end loop;
            Salir:=True;

         end if;


         -- SE REPITE EL BUCLE HASTA QUE TODOS LOS TROZOS DEL FICHERO HAN SIDO MANDADOS Y ASENTIDOS (EXCEPTO SI
         -- EL LTIMO ES DE TAMAO 0)

         while (not S_IO.End_Of_File (Direccion_Fichero)) or (not Salir)loop

            -- SI ME HAN ASENTIDO EL LTIMO TROZO MANDADO, LEO EL SIGUIENTE DEL FICHERO

            if Numero_Trozo=Num_Trozo_Aux then
               Numero_Trozo:= Numero_Trozo+1;
               Num_Trozo_Aux:= Numero_Trozo-1;
               S_IO.Read (Direccion_Fichero, Trozo, Ultimo);
            end if;

            -- EL BUCLE SE REPITE HASTA QUE SE RECIBE UN ASENTIMIENTO POR PARTE DEL SERVIDOR

            loop

               -- METO EN EL BUFFER EL TROZO DE FICHERO Y LO MANDO

               LLU.Reset (Buffer);
               Natural'Output (Buffer'Access, 3);
               Natural'Output (Buffer'Access, Numero_Trozo);
               Ada.Streams.Stream_Element_Array'Output (Buffer'Access, Trozo(1..Ultimo));
               LLU.Send (Client_EP, Buffer'Access);
               Put_Line ("Mando la parte del fichero" & Integer'Image (Numero_Trozo));

               -- ESPERO EL ASENTIMIENTO DEL CLIENTE
               LLU.Reset (Buffer);
               LLU.Receive (Server_EP, Buffer'Access,Duration (Plazo_Espera), Expired);

               -- SI HE RECIBIDO UN PAQUETE DE ASENTIMIENTO ME SALGO DEL BUCLE

               if  not Expired then
                  -- Compruebo lo siguiente por si el primer paquete de datos se ha perdido
                  -- Y el cliente me manda otra vez la solicitud de lectura
                  Client_EP:= LLU.End_Point_Type'Input (Buffer'Access);
                  Tipo:= Natural'Input (Buffer'Access);
                  if Tipo=4 then
                     exit; -- Si recibo un asentimiento  del cliente me salgo del bucle
                  end if;
               end if;
            end loop;

            Num_Trozo_Aux:= Natural'Input (Buffer'Access);
            Put_Line ("Recibo asentimiento del trozo: " & Integer'Image (Num_Trozo_Aux));

            -- Si es final de fichero, y el trozo asentido es el ltimo trozo mandado, me salgo del bucle
            if S_IO.End_Of_File (Direccion_Fichero) and (Num_Trozo_Aux= Numero_Trozo) then Salir:= True; end if;
         end loop;

         -- SI EL LTIMO TROZO QUE HE MANDADO ES DE Tamano_Trozo bytes LE MANDO OTRO PAQUETE CON UN TROZO DE FICHERO
         -- VACIO (LONGITUD 0) PARA QUE EL CLIENTE SEPA QUE EL FICHERO HA TERMINADO

         Numero_Trozo:= Numero_Trozo+1;
         if Integer(Ultimo)=Tamano_Trozo then
            loop

               -- METO EN EL BUFFER UN TROZO DE FICHERO VACO Y LO ENVO AL CLIENTE

               LLU.Reset (Buffer);
               Natural'Output (Buffer'Access, 3);
               Natural'Output (Buffer'Access, Numero_Trozo);
               Ada.Streams.Stream_Element_Array'Output (Buffer'Access, Trozo (1..0));
               LLU.Send (Client_EP, Buffer'Access);
               Put_Line ("Mando ltima parte del fichero vaca " & Integer'Image (Numero_Trozo));

               -- ESPERO EL ASENTIMIENTO DEL SERVIDOR

               LLU.Reset (Buffer);
               LLU.Receive (Server_EP, Buffer'Access,Duration(Plazo_Espera), Expired);

               -- SI HE RECIBIDO UN ASENTIMIENTO, COMPRUEBO QUE ES EL DEL LTIMO TROZO DE FICHERO (VACIO) , Y EN
               -- ESE CASOME SALGO DEL BUCLE, EN CASO CONTRARIO VUELVE LA ITERACIN DEL BUCLE Y VUELVE A MANDAR
               -- EL LTIMO PAQUETE (TROZ VACO)

               if not Expired then
                  Client_EP:= LLU.End_Point_Type'Input (Buffer'Access);
                  Tipo:= Natural'Input (Buffer'Access);
                  Num_Trozo_Aux:= Natural'Input (Buffer'Access);
                  if Num_Trozo_Aux = Numero_Trozo then
                     Put_Line ("Recibo asentimiento del trozo" & Integer'Image (Numero_Trozo));
                     exit;
                  end if;
               end if;
            end loop;
         end if;
      end; -- Declare
      S_IO.Close (Direccion_Fichero);

   end Peticion_Lectura;



   -- *******************************************************************************************************
   -- ***************************************** PROGRAMA PRINCIPAL ******************************************
   -- *******************************************************************************************************



begin

   -- DEFINO EL VECTOR DE FALLOS

   LLU.Set_Faults_Vector ( (True,True,True,False, True, True, False, True, True, True, False) );

   -- CONSTRUYO LA DIRECCIN DEL SERVIDOR Y ME ATO A ELLA

   Server_EP:= LLU.Build ("127.0.0.1",6123);
   LLU.Bind (Server_EP);


   loop

      -- ME QUEDO ESPERANDO HASTA RECIBIR ALGUNA PETICIN

      LLU.Reset (Buffer);
      LLU.Receive (Server_EP, Buffer'Access, 1000.0, Expired);

      if Expired then
         Put_Line ("El servidor se cansa de esperar ....");
      else

         -- CUANDO RECIBO UNA PETICIN SACO LOS DATOS DEL BUFFER

         Client_EP:= LLU.End_Point_Type'Input (Buffer'Access);
         Tipo:= Natural'Input (Buffer'Access);
         Fichero:= ASU.Unbounded_String'Input (Buffer'Access);
         Put ("Recibo peticin de ");
         if Tipo=2 then Put ("escritura");
         else Put ("lectura"); end if;
         Put_Line ("del fichero: " & ASU.To_String (Fichero));

         if Tipo=2 then -- escritura
            Peticion_Escritura;
         else  -- lectura:
            Peticion_Lectura;
         end if;
         Put_Line ("Fin de la conexin con el cliente");
      end if;
   end loop;

   LLU.UnBind (Server_EP);
end Servidor;


